package com.jiuqi.grid;

import com.jiuqi.util.MemStream;
import com.jiuqi.util.Stream;
import com.jiuqi.util.StreamException;
import java.io.Serializable;
import java.util.Hashtable;
import java.util.Map;

/* loaded from: com_jiuqi_grid.jar:com/jiuqi/grid/ExtendedDatas.class */
public class ExtendedDatas implements Serializable, Cloneable {
    private Hashtable extDatas = new Hashtable();

    public byte[] getData(String name) {
        return (byte[]) this.extDatas.get(name);
    }

    public void setData(String name, byte[] data) {
        if (data == null || data.length == 0) {
            this.extDatas.remove(name);
        } else {
            this.extDatas.put(name, data);
        }
    }

    public void setData(String name, int[] data) {
        if (data == null || data.length == 0) {
            this.extDatas.remove(name);
            return;
        }
        MemStream stream = new MemStream();
        for (int i : data) {
            try {
                stream.writeInt(i);
            } catch (StreamException e) {
                e.printStackTrace();
                return;
            }
        }
        setData(name, stream.getBytes());
    }

    public void clear() {
        this.extDatas.clear();
    }

    public boolean contains(String name) {
        return this.extDatas.containsKey(name);
    }

    public void loadFromStream(Stream stream, int size) throws StreamException {
        clear();
        while (stream.getPosition() < size) {
            String key = stream.readString(stream.readInt());
            int len = stream.readInt();
            byte[] data = new byte[len];
            stream.readBuffer(data, 0, len);
            this.extDatas.put(key, data);
        }
    }

    public void saveToStream(Stream stream) throws StreamException {
        for (Map.Entry item : this.extDatas.entrySet()) {
            String key = (String) item.getKey();
            stream.writeInt(key.length());
            stream.writeString(key);
            byte[] data = (byte[]) item.getValue();
            stream.writeInt(data.length);
            stream.writeBuffer(data, 0, data.length);
        }
    }

    protected Object clone() {
        try {
            ExtendedDatas result = (ExtendedDatas) super.clone();
            result.extDatas = new Hashtable(this.extDatas);
            return result;
        } catch (CloneNotSupportedException unused) {
            return null;
        }
    }
}
